/*
----------------------------------------------------------------------------
"THE BEER-WARE LICENSE" (Revision 42):
<erik at sitadella.com> wrote this file. As long as you retain this notice you
can do whatever you want with this stuff. If we meet some day, and you think
this stuff is worth it, you can buy me a beer in return. -Erik A. Hansen (EAH)
----------------------------------------------------------------------------
LimID.ino

Changelog:
2012-06-24 - Publicly released!

*/



//Includes
#include <Servo.h> ;
  

//Declare constants and variables
int inByte = 0;
char frame[2] = {0, '\0'};
const int PinServo = 9;
const int PinLed1 = 11;
const int PinLed2 = 12;
const int PinLed3 = 13;
String str;


//Setup
void setup() {                
 Serial.begin(9600);
 delay(1000);
 pinMode(PinLed1, OUTPUT);
 pinMode(PinLed2, OUTPUT);
 pinMode(PinLed3, OUTPUT);
}


//Loop
void loop() {
 establishContact();
 WaitReceiveTwo();
 ControlLights(1);
 PushButton();
 InformPcComplete();
 delay(3000); //Allow PC sufficient time to take picture. Value needs tweaking.
 ControlLights(0);
}
  
  
void establishContact() {
 while (Serial.available() <= 0) {
  Serial.println("1");
  delay(300);
 }
}


void ControlLights(boolean bOnoff) {
 //Serial.println("Controling LEDs...");
 digitalWrite(PinLed1, bOnoff);
 digitalWrite(PinLed2, bOnoff);
 digitalWrite(PinLed3, bOnoff);
}


void PushButton() {
 //Serial.println("Pushing button...");
 Servo ServoButton;
 ServoButton.attach(PinServo);
 ServoButton.write(40);
 delay(50);
 ServoButton.write(0);
 delay(50);
 ServoButton.detach();
}


void InformPcComplete() {
 //Serial.println("Informing PC finished...");
 Serial.println(2);
}

 
void WaitReceiveTwo(){
 while (1){
  if (Serial.available() > 0) {
   frame[0] = (char)Serial.read();
   inByte = atoi(frame);
   //Serial.println('3'); //Something was received over serial, continue loop
   if (inByte == 2){
    //Serial.println('4'); //A one was received over serial, break loop
    break; 
   }
  } 
 }
}

