## ----------------------------------------------------------------------------
## "THE BEER-WARE LICENSE" (Revision 42):
## <erik at sitadella.com> wrote this file. As long as you retain this notice you
## can do whatever you want with this stuff. If we meet some day, and you think
## this stuff is worth it, you can buy me a beer in return. -Erik A. Hansen (EAH)
## ----------------------------------------------------------------------------
## LimID.py
##
##
## Changelog:
## 2012-06-24 - Publicly released!
##
##
## Notes:
## Some lines of code have been commented out. More specifically, the script does not
##  attempt to communicate with the Arduino nor does it attempt to capture an image 
## from the webcam, instead, it relies on a test image (webcam.png) which should be 
## located in the same folder as LimID.py. This will hopefully make it easier for others to
##  get started with and test LimID.


##################################################
##################################################
###                Functions
##################################################
##################################################
import cv
import Image
import ImageFilter
import ImageChops
import os
import pygtk
pygtk.require('2.0')
import gtk
import PIL
from PIL import ImageFont
from PIL import Image
from PIL import ImageDraw
import PIL.ImageOps 
import pynotify
import pyosd
import serial
import subprocess
import sys
import time
from time import localtime, strftime


##################################################
##################################################
###                Functions
##################################################
##################################################
def popup(title,message, imgpath): #Seems to require that notify-osd be installed and that notification-daemon NOT be installed
 try:
  if pynotify.init("LimID"):
   Alert = pynotify.Notification(title, message, imgpath)
   Alert.show()
  else:
   print "Error starting pynotify"
   popupv2(message)
 except:
  print "pynotify not installed"
  popupv2(message)


def popupv2(message): #Cross-platform? An alternative notification function that doesn't require notify-osd.
 p = pyosd.osd()
 p.set_colour('#31E000')
 p.set_font('-*-Times-Bold-R-*--*-350-*-*-*-*-ISO8859-1') #-adobe-helvetica-medium-r-normal-*-*-400-*-*-p-*-iso8859-1
 p.set_align(pyosd.ALIGN_RIGHT)
 p.set_pos(pyosd.POS_TOP)
 p.set_offset(100)
 p.display(message)
 #time.sleep(10)
 p.wait_until_no_display()


def verifyalldigits(string):
 for char in string:
  if "0123456789".find(char)==-1:
   return 0
   break
 return 1


def createuniquefilename(bankkode):
 return sys.path[0] + "/" + "OCRArchive" + "/" + strftime("%Y%m%d%H%M%S", localtime()) + " " + bankkode + ".png"


def GetSegments(xlist, ylist):
 im = Image.open(webcamProcessedpath)
 pix = im.load()
 t = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42] #A silly way of making a list with 42 elements
 print "Segment#", "x-coord", "y-coord", "PixelOnOff"
 for i in range( len( xlist ) ):
  if pix[xlist[i], ylist[i]] == (255, 255, 255):
   t[i] = 0
  elif pix[xlist[i], ylist[i]] == (0, 0, 0):
   t[i] = 1
  print i, xlist[i], ylist[i], t[i]
 return t


def OCRSixDigits(pixelsonoff):
 Digit1 = SSOCR(pixelsonoff[0:7])
 Digit2 = SSOCR(pixelsonoff[7:14])
 Digit3 = SSOCR(pixelsonoff[14:21])
 Digit4 = SSOCR(pixelsonoff[21:28])
 Digit5 = SSOCR(pixelsonoff[28:35])
 Digit6 = SSOCR(pixelsonoff[35:42])
 bankkode = str(Digit1) + str(Digit2) + str(Digit3) + str(Digit4) + str(Digit5) + str(Digit6)
 if bankkode == "888888": #Probably means that the OCR was performed on a completely black image
  return ""
 if bankkode == "111111": #Probably means that the OCR was performed on a completely white image
  return ""
 else:
  return bankkode


def removefromstring(possibledigits, chars):
 for digit in chars:
  possibledigits = possibledigits.replace(digit, "")
 return possibledigits


def SSOCR(sevensegments):
 if sevensegments == [1,1,1,1,1,1,0]: #0
  return 0
 elif sevensegments == [0,1,1,0,0,0,0]: #1
  return 1
 elif sevensegments == [1,1,0,1,1,0,1]: #2
  return 2
 elif sevensegments == [1,1,1,1,0,0,1]: #3
  return 3
 elif sevensegments == [0,1,1,0,0,1,1]: #4
  return 4
 elif sevensegments == [1,0,1,1,0,1,1]: #5
  return 5
 elif sevensegments == [1,0,1,1,1,1,1]: #6
  return 6
 elif sevensegments == [1,1,1,0,0,1,0]: #7
  return 7
 elif sevensegments == [1,1,1,1,1,1,1]: #8
  return 8
 elif sevensegments == [1,1,1,1,0,1,1]: #9
  return 9
 possibledigits = "1472356098" #List of digits sorted by the number of segments (the digit 1 only uses 2 of seven segments, the digit 8 uses all seven segments)
 if sevensegments[0]:  
  possibledigits = removefromstring(possibledigits, "14")    #If segment a is on then the digit being OCRed is probably not 14
 if sevensegments[1]: 
  possibledigits = removefromstring(possibledigits, "56")    #If segment b is on then the digit being OCRed is probably not 56
 if sevensegments[2]:
  possibledigits = removefromstring(possibledigits, "2")     #If segment c is on then the digit being OCRed is probably not 2
 if sevensegments[3]:
  possibledigits = removefromstring(possibledigits, "147")   #If segment d is on then the digit being OCRed is probably not 147
 if sevensegments[4]:
  possibledigits = removefromstring(possibledigits, "13457") #If segment e is on then the digit being OCRed is probably not 13457
 if sevensegments[5]:
  possibledigits = removefromstring(possibledigits, "123")   #If segment f is on then the digit being OCRed is probably not 123
 if sevensegments[6]:
  possibledigits = removefromstring(possibledigits, "017")   #If segment g is on then the digit being OCRed is probably not 017
 return possibledigits[0] #The digit which requires the fewest aditional segments


##################################################
##################################################
###                Start
##################################################
##################################################
print "Setting variables..."
starttime = time.time()
webcamname = "webcam.png"
webcamProcessedname = "webcamProcessed.png"
webcampath = sys.path[0] + "/" + webcamname
webcamcroppedpath = sys.path[0] + "/" + "webcamcropped.png"
webcamProcessedpath = sys.path[0] + "/" + webcamProcessedname
whitebarspath = sys.path[0] + "/whitebars.png"
regionrefpath = sys.path[0] + "/" + "regionref.png"
whitebackgroundpath = sys.path[0] + "/" + "whitebackground.png"


####################################################
####################################################
#####                Communicate with Arduino
####################################################
####################################################
##print "Connecting to Arduino..."
##msgarduino = 0
##for portnumber in range(0, 5):
## portname = '/dev/ttyACM' + str(portnumber) #Not cross-platform
## try:
##  ser = serial.Serial(port = portname, baudrate = 9600, timeout = 5)
##  print "Connected to Arduino on port " + portname + "..."
##  break
## except:
##  pass
##print "Sending a 1, pausing, then sending a 2 to the Arduino..."
###time.sleep(1)
##ser.write(str(1)) #ser.write(str(1)+'\n')
##time.sleep(1)
##ser.write(str(2)) #ser.write(str(1)+'\n')
##
##print "Waiting to receive a 2 from the Arduino..."
##arduinostart = time.time()
##while 1:
## try:
##  while 1:
##   arduinotime = int(time.time() - arduinostart)
##   if arduinotime > 3:
##    print "Receive timeout..."
##    os._exit(2) #Code to exit script, but not the interpreter?
##   msgarduino = int(ser.readline())
##   if isinstance(msgarduino, (int, long)):
##    break
## except ValueError:
##  pass
## if msgarduino == 2:
##  print "2 received from the Arduino..."
##  break
###time.sleep(1)
##
##
##################################################
##################################################
#####                Capturing image from webcam
##################################################
##################################################
##print "Capturing image from webcam..."
##capture = cv.CaptureFromCAM(0) #How can a specific webcam be specified?
##img = cv.QueryFrame(capture)
##cv.SaveImage(webcampath, img)
##del(capture)
##sys.exit(1)


##################################################
##################################################
###                Preparing image for OCR
##################################################
##################################################
print "Preparing image for OCR..."
region = Image.open(webcampath)
region = region.rotate(-3)
box = (60, 230, 620, 430)
region = region.crop(box)
region.save(webcamcroppedpath)
regionref = Image.open(regionrefpath)
region = ImageChops.subtract(regionref,region) #This line of code improved reliability of OCR by approximately 740%!
region = PIL.ImageOps.invert(region)
threshold = 240  
region = region.point(lambda p: p > threshold and 255)
for _ in range(3):
 region = region.filter(ImageFilter.MedianFilter(9))
whitebars = Image.open(whitebarspath)
region.paste(whitebars, (0, 0), whitebars)
region.save(webcamProcessedpath)


##################################################
##################################################
###                OCRing image
##################################################
##################################################
print "OCRing image..."
xlist = [50,75,70,40,15,20,45,140,165,160,130,105,110,135,230,255,250,220,195,200,225,320,345,340,310,285,290,315,410,435,430,400,375,380,405,500,525,520,490,465,470,495]
ylist = [15,50,130,170,130,50,90,15,50,130,170,130,50,90,20,55,135,175,135,55,95,20,55,135,175,135,55,95,20,55,135,175,135,55,95,20,55,135,175,135,55,95]
pixelsonoff = GetSegments(xlist,ylist)
bankkode = OCRSixDigits(pixelsonoff)


##################################################
##################################################
###                Archiving OCR image
##################################################
##################################################
print "Archiving OCR image for Hall of Fame..."
if (len(str(bankkode))>0):
 region = Image.open(webcamcroppedpath)
 region2 = Image.open(webcamProcessedpath)
 whitebackground = Image.open(whitebackgroundpath)
 font = ImageFont.truetype("/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf",140) #Not cross-platform
 draw = ImageDraw.Draw(whitebackground)
 draw.text((0, 400),bankkode,(0,0,0),font=font)
 whitebackground.paste(region, (0,0))
 whitebackground.paste(region2, (0,200))
 #draw = ImageDraw.Draw(whitebackground)
 #draw = ImageDraw.Draw(whitebackground)
 whitebackground.save(createuniquefilename(bankkode))


##################################################
##################################################
###                Finishing
##################################################
##################################################
print "Finishing..."
runtime = str(int(time.time() - starttime))
if (verifyalldigits(bankkode) and len(bankkode)==6): #Check if bankkode is a valid 6 digit number
 clipboard = gtk.clipboard_get() #Not cross-platform
 clipboard.set_text(bankkode)
 clipboard.store()
 subprocess.call(["xte", "key " + bankkode[0] ,"key " + bankkode[1] ,"key " + bankkode[2] ,"key " + bankkode[3] ,"key " + bankkode[4] ,"key " + bankkode[5],"key Return"]) #Not cross-platform 
 popup("LimID", "Engangskode: " + bankkode, webcamProcessedpath)
else:
 popup("LimID", "Noe gikk galt! (" + bankkode + ").", webcamProcessedpath)
print "OCRed code: " + bankkode + ". Time: ", runtime, " seconds."
#sys.exit(exitcode) Return bankkode as exitcode to calling program (e.g. php script) (By using an exit code?)
#Remove files
#if os.path.exists(webcampath):
 #os.remove(webcampath)
#if os.path.exists(webcamProcessedpath):
 #os.remove(webcamProcessedpath)
